// GTIFMakerDoc.cpp : implementation of the CGTIFMakerDoc class
//

#include "stdafx.h"
#include "GTIFMaker.h"

#include "GTIFMakerDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGTIFMakerDoc

IMPLEMENT_DYNCREATE(CGTIFMakerDoc, CDocument)

BEGIN_MESSAGE_MAP(CGTIFMakerDoc, CDocument)
	//{{AFX_MSG_MAP(CGTIFMakerDoc)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGTIFMakerDoc construction/destruction

CGTIFMakerDoc::CGTIFMakerDoc()
{
	m_DIB = NULL;
}

CGTIFMakerDoc::~CGTIFMakerDoc()
{
}

BOOL CGTIFMakerDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CGTIFMakerDoc serialization

void CGTIFMakerDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CGTIFMakerDoc diagnostics

#ifdef _DEBUG
void CGTIFMakerDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGTIFMakerDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGTIFMakerDoc commands

void CGTIFMakerDoc::OnFileOpen() 
{
	CFileDialog dlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, "Image Files (*.tif, *.jpg, *.bmp, *.png)|*.tif;*.jpg;*.bmp;*.png|All Files (*.*)|*.*||");

	if(dlg.DoModal() != IDOK)
		return;

	m_DIB = FreeImage_Load(FreeImage_GetFileType(dlg.GetPathName(), 16), dlg.GetPathName());

	UpdateAllViews(NULL);
}

/* GeoTiff Save Routine
 * Coded by Scene, Sanghee(endofcap@freechal.com)
 * August, 2001
 * Copyright(c) 2001 Scene, Sanghee
*/ 
void CGTIFMakerDoc::OnFileSave() 
{
	double tiepoints[] = { 0, 0, 0, 200000, 500000, 0 };		// ġ  ..
	double pixscale[] =	 { 30, 30, 0 };							//  ػ..

	uint32 height;
	uint32 width;
	uint32 rowsperstrip = (uint32) -1;
	uint16 bitspersample;
	uint16 samplesperpixel;
	uint16 photometric;

	BYTE *bits, *lpBits;	// pointers to dib data
	uint16 pitch;
	uint32 x, y;
	tsize_t linebytes;
	char* buf;

	// tif gtif ͸ ...
	TIFF* tif = (TIFF*)0;
	GTIF* gtif = (GTIF*)0;

	// dib  ..
	if(m_DIB == NULL)
		return;

	//  GeoTiff ϰ..
	CFileDialog dlg(FALSE, NULL, NULL, OFN_HIDEREADONLY, "GeoTiff File (*.tif)|*.tif||");

	if(dlg.DoModal() != IDOK)
		return;

	//  ..
	tif = XTIFFOpen(dlg.GetPathName(), "w+"); 

	if (!tif) 
		AfxMessageBox("An ERROR!!");   //    翬  ߰.

	gtif = GTIFNew(tif); // GeoTiff ϰڴٰ մϴ.  Լ(GTIFNew() GTIFFree()  ̷մϴ.

	// Tiff Setup    ..
	width = FreeImage_GetWidth(m_DIB);
	height = FreeImage_GetHeight(m_DIB);
	bitspersample = FreeImage_GetBPP(m_DIB);
	samplesperpixel = (bitspersample == 24) ? 3 : 1;
	photometric = CheckPhotometric(m_DIB, bitspersample);

	// Tiff SetUp
	TIFFSetField(tif, TIFFTAG_IMAGEWIDTH, width);		// width
	TIFFSetField(tif, TIFFTAG_IMAGELENGTH, height);		// height
	TIFFSetField(tif, TIFFTAG_SAMPLESPERPIXEL, samplesperpixel);	// color depth
	TIFFSetField(tif, TIFFTAG_BITSPERSAMPLE, bitspersample / samplesperpixel);	// bps
	TIFFSetField(tif, TIFFTAG_PHOTOMETRIC, photometric);
	TIFFSetField(tif, TIFFTAG_PLANARCONFIG, PLANARCONFIG_CONTIG);	// single image plane 
	TIFFSetField(tif, TIFFTAG_ORIENTATION, ORIENTATION_TOPLEFT);	// orientation
	TIFFSetField(tif, TIFFTAG_ROWSPERSTRIP, TIFFDefaultStripSize(tif, rowsperstrip));
	TIFFSetField(tif, TIFFTAG_COMPRESSION, COMPRESSION_NONE);		// compression

	// GeoTiff Setup
	TIFFSetField(tif, TIFFTAG_GEOTIEPOINTS, 6, tiepoints);	// GTIF TIEPoint  ݴϴ. tiepoints tiepoints[6]Դϴ.
	TIFFSetField(tif, TIFFTAG_GEOPIXELSCALE, 3, pixscale);	// GTIF ػ󵵸 ־ش..

	// GeoTiff GeoKey SetUPش..
	// Step 1 -- GeoTiff Configuration Keys
	GTIFKeySet(gtif, GTModelTypeGeoKey, TYPE_SHORT, 1, ModelTypeProjected);
	GTIFKeySet(gtif, GTRasterTypeGeoKey, TYPE_SHORT, 1, RasterPixelIsArea);
	GTIFKeySet(gtif, GTCitationGeoKey, TYPE_ASCII, 0, "Test for Korean GeoTiff");

	// Step 2 -- Code Setup ߺο ....
	GTIFKeySet(gtif, ProjectedCSTypeGeoKey, TYPE_SHORT,  1, GCS_Tokyo );
	GTIFKeySet(gtif, PCSCitationGeoKey, TYPE_ASCII, 0, "Ellipse_Bessel_1841 Used");
	GTIFKeySet(gtif, ProjCoordTransGeoKey, TYPE_SHORT, 1, CT_TransverseMercator);
	GTIFKeySet(gtif, ProjLinearUnitsGeoKey, TYPE_SHORT,  1, Linear_Meter);
	GTIFKeySet(gtif, ProjFalseEastingGeoKey, TYPE_DOUBLE,  1, (double)200000.0);
	GTIFKeySet(gtif, ProjFalseNorthingGeoKey, TYPE_DOUBLE,  1, (double)500000.0);
	GTIFKeySet(gtif, ProjCenterLongGeoKey, TYPE_DOUBLE,  1, (double)127.00289027777777777777);
	GTIFKeySet(gtif, ProjCenterLatGeoKey, TYPE_DOUBLE,  1, (double)38.);
	GTIFKeySet(gtif, ProjScaleAtCenterGeoKey, TYPE_DOUBLE, 1, (double)1.0);

	//  TIFF  ô..
	linebytes = width * samplesperpixel;

	if (TIFFScanlineSize(tif) > linebytes) 
		linebytes = TIFFScanlineSize(tif);
	
	buf = (char *)_TIFFmalloc(linebytes);	

	// read the DIB lines from bottom to top
	// and save them in the TIF
	// -------------------------------------
	lpBits = FreeImage_GetBits(m_DIB);
	pitch = FreeImage_GetPitch(m_DIB);;
	
	switch(bitspersample) 
	{				
		case 1 :
		case 4 :
		case 8 :
		{
			for (y = 0; y < height; y++) 
			{
				bits = FreeImage_GetBitsRowCol(m_DIB, 0, y);

				TIFFWriteScanline(tif,bits, y, 0);
			}
			break;
		}				

		case 24 :
		{
			char*	pBuf;

			for (y = 0; y < height; y++) 
			{
				bits = lpBits + (pitch * (height-1-y));
				pBuf = buf;

				for (x = 0; x < width; x++) 
				{
					pBuf[0] = bits[2];
					pBuf[1] = bits[1];
					pBuf[2] = bits[0];
					pBuf += 3; bits += 3;
				}
				TIFFWriteScanline(tif, buf, y, 0);
			}
			break;
		}				
	}
	GTIFWriteKeys(gtif);  // GTIFWriteKeys     GTIF Ͽ  ʽϴ.
	GTIFFree(gtif);		// GTIF Ǯֱ..
	XTIFFClose(tif);	// TIF ݽϴ.
}

UINT CGTIFMakerDoc::CheckPhotometric(FIBITMAP* _dib, UINT _bitspersample) 
{
	RGBQUAD *rgb;
	UINT	i;

	switch(_bitspersample) 
	{
		case 1:
		{
			rgb = FreeImage_GetPalette(m_DIB);

			if ((rgb->rgbRed == 0) && (rgb->rgbGreen == 0) && (rgb->rgbBlue == 0)) 
			{
				rgb++;
				if ((rgb->rgbRed == 255) && (rgb->rgbGreen == 255) && (rgb->rgbBlue == 255)) 
					return PHOTOMETRIC_MINISBLACK;
				
			}
			if ((rgb->rgbRed == 255) && (rgb->rgbGreen == 255) && (rgb->rgbBlue == 255)) 
			{
				rgb++;
				if ((rgb->rgbRed == 0) && (rgb->rgbGreen == 0) && (rgb->rgbBlue == 0)) 
					return PHOTOMETRIC_MINISWHITE;
			}

			return PHOTOMETRIC_PALETTE;
		}

		case 4:	// Check if the DIB has a color or a greyscale palette
		case 8:
			rgb = FreeImage_GetPalette(m_DIB);

			for (i = 0; i < FreeImage_GetColorsUsed(m_DIB); i++) 
			{
				if ((rgb->rgbRed != rgb->rgbGreen) || (rgb->rgbRed != rgb->rgbBlue)) 
					return PHOTOMETRIC_PALETTE;
				
				// The DIB has a color palette if the greyscale isn't a linear ramp
				if (rgb->rgbRed != i) 
					return PHOTOMETRIC_PALETTE;

				rgb++;
			}

			return PHOTOMETRIC_MINISBLACK;
			
		case 24:
			return PHOTOMETRIC_RGB;			
	}
	return PHOTOMETRIC_MINISBLACK;
}