// GTIFMakerDoc.h : interface of the CGTIFMakerDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GTIFMAKERDOC_H__E36CE473_10B8_44BA_9EE3_8A12742CF9E5__INCLUDED_)
#define AFX_GTIFMAKERDOC_H__E36CE473_10B8_44BA_9EE3_8A12742CF9E5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FreeImage.h"
#include "GeoTiff/geotiffio.h"  /* public interface        */
#include "GeoTiff/geo_tiffp.h"	/* external TIFF interface */
#include "GeoTiff/geo_keyp.h"	/* private interface       */

class CGTIFMakerDoc : public CDocument
{
protected: // create from serialization only
	CGTIFMakerDoc();
	DECLARE_DYNCREATE(CGTIFMakerDoc)

// Attributes
public:
	FIBITMAP*	m_DIB;

// Operations
public:
	UINT		CheckPhotometric(FIBITMAP* _dib, UINT _bitspersample);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGTIFMakerDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGTIFMakerDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGTIFMakerDoc)
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GTIFMAKERDOC_H__E36CE473_10B8_44BA_9EE3_8A12742CF9E5__INCLUDED_)
